﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Windows.Diagrams.Core;

namespace _1126581DiagramBrowsableAttribute
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();

            this.radDiagram1.SelectionChanged+=radDiagram1_SelectionChanged;
            this.radDiagram1.DataSource = new Source();
             
            this.radDiagram1.ShapeDataMember = "Tasks";
            this.radDiagram1.ShapeIdMember = "Id";  
            this.radDiagram1.ShapeTextMember = "Text";
            this.radDiagram1.ShapeTypeMember = "Type";
            this.radDiagram1.ShapeXMember = "X";
            this.radDiagram1.ShapeYMember = "Y";
            this.radDiagram1.ShapeWidthMember = "Width";
            this.radDiagram1.ShapeHeightMember = "Height";
        }

        private void radDiagram1_SelectionChanged(object sender, EventArgs e)
        {
            DiagramSelectionChangedEventArgs args = e as DiagramSelectionChangedEventArgs;
            if (args!=null&& args.AddedItems.Count>0)
            {
                this.radPropertyGrid1.SelectedObject = args.AddedItems[0];
            }
        }

        public class Source
        {
            public BindingList<Task> Tasks
            {
                get
                {
                    return GetTasks();
                }
            }

            private BindingList<Task> GetTasks()
            {
                return new BindingList<Task>()
                {
                    new Task() { Id = "Task1", Text = "Task 1", Type = "circle", X = 100, Y = 300, Width = 50, Height = 50 },
                    new Task() { Id = "Task2", Text = "Task 2", Type = "rectangle", X = 200, Y = 100, Width = 100, Height = 100 },
                    new Task() { Id = "Task3", Text = "Task 3", Type = "circle", X = 300, Y = 300, Width = 50, Height = 50 },
                    new Task() { Id = "Task4", Text = "Task 4", Type = "rectangle", X = 400, Y = 100, Width = 100, Height = 100 },
                    new Task() { Id = "Task5", Text = "Task 5", Type = "circle", X = 500, Y = 300, Width = 50, Height = 50 }
                };
            }
        }

        public class Task : INotifyPropertyChanged
        {
            private string id;
            private string text;
            private string type;
            private double x;
            private double y;
            private double width;
            private double height;

            public string Id
            {
                get
                {
                    return this.id;
                }
                set
                {
                    this.id = value;
                    if (this.id != value)
                    {
                        this.id = value;
                        OnPropertyChanged("Id");
                    }
                }
            }

            public string Text
            {
                get
                {
                    return this.text;
                }
                set
                {
                    this.text = value;
                    if (this.text != value)
                    {
                        this.text = value;
                        OnPropertyChanged("Text");
                    }
                }
            }

            public string Type
            {
                get
                {
                    return this.type;
                }
                set
                {
                    if (this.type != value)
                    {
                        this.type = value;
                        OnPropertyChanged("Type");
                    }
                }
            }

            [Browsable(false)]
            public double X
            {
                get
                {
                    return this.x;
                }
                set
                {
                    if (this.x != value)
                    {
                        this.x = value;
                        OnPropertyChanged("X");
                    }
                }
            }

             [Browsable(false)]
            public double Y
            {
                get
                {
                    return this.y;
                }
                set
                {
                    this.y = value;
                    if (this.y != value)
                    {
                        this.y = value;
                        OnPropertyChanged("Y");
                    }
                }
            }

            public double Height
            {
                get
                {
                    return this.height;
                }
                set
                {
                    if (this.height != value)
                    {
                        this.height = value;
                        OnPropertyChanged("Height");
                    }
                }
            }

            public double Width
            {
                get
                {
                    return this.width;
                }
                set
                {
                    if (this.width != value)
                    {
                        this.width = value;
                        OnPropertyChanged("Width");
                    }
                }
            }

            private void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }

            public event PropertyChangedEventHandler PropertyChanged;
        }
    }
}